#include <PropLcc.h>
#include <tv_text_array.h>
/*******************************************************************************
Code Specific
*/

#define TXPIN      30
#define RXPIN      31
#define BAUD    19200

/********************************************************************************************
Global variables
*/
	long rxStack[50]; /*  Now inplemented */
    char buf[buflen]; /*  Text Buffer max length   */
    int cx;           /*  char from input stream   */
	int pb,po;        /*  Text Buffer pointer, TV offset pointer  */
	char cc;          /*  character hidden by cursor     */
    int id = 0;       /*  tv cog #    */
	int z,j;          /*  Keyboard Buffer input pointer, output pointer  */ 
   	char cmdbuf[20];  /*  Holds command string   */
	char kb[64];      /*  Keyboard Buffer */
		 
/***************************************************************************************/			         
prototype........provide documentation here DONT PUT IT OFF....to me 
   
    void getcx();                 

    void keyin();

    void tvText_out(unsigned int);

    void tvText_stop(void)

    int tvText_start(int basepin)

    void tvText_setColorPalette(char* ptr);

    void tvText_dec(int value);

    void tvText_str(char* sptr);

    void cmd();

    void screen_update()  
/******************************************************************************************/

Start of MAIN */

void main()                             
{    j=0;                                 /* init getcx pointer                 */
     z=0;                                 /* init keyin pointer                 */
	 tvText_start(12);                    /* start tv at basepin                */ 
     TaskNew( &keyin, &rxStack[0], 50 );  /* TaskNew starts keyboard handler    */
   	 while(1)                             /* go for it                          */
	   { getcx();                         /* get next char in keyboard buffer   */
	   if (cx!=0x0) { tvText_out(cx); }   /* clear screen not allowed here      */
       }
}

/******************************************************************************************
start Tv in its own cog */

int tvText_start(int basepin)          
 {  int i;
    gTvText.status = 0;          
    gTvText.enable = 1;
    gTvText.pins   = ((basepin & 0x38) << 1) | (((basepin & 4) == 4) ? 0b101 : 0); 
    gTvText.mode   = 0b10010;
    gTvText.screen = gscreen;    
    gTvText.colors = gcolors;
    gTvText.ht = TV_TEXT_COLS;
    gTvText.vt = TV_TEXT_ROWS;
    gTvText.hx = 4;
    gTvText.vx = 1;
    gTvText.ho = 0;
    gTvText.vo = 0;
    gTvText.broadcast = 0;
    gTvText.auralcog  = 0;
    id = cognewNative(TV_Text_Array, &gTvText);           /* NOT IMPLEMENTED ATM */
    gTvTextCog = id+1;                                    /* THEN WE ARE IN BUSINESS */ 
    tvText_setColorPalette(&gpalette[TV_TEXT_PAL_WHITE_BLUE]);
    WordFill(&gscreen[0],0x220, TV_TEXT_SCREENSIZE);                  
	for(i=0; i<=buflen; i++) { buf[i]=0x20;}
    waitcnt(CLKFREQ/8000 + CNT);;                    
    return id;
  }
	

/*******************************************************************************************************
stops the cog running the native assembly driver. 
Use spinc 'filename' to generate filename_array_h suitable for loading 
with cogNewNative see PropLCC.h CogNewNative not implemented ATM */
 
 
void tvText_stop(void) 
   { int id = gTvTextCog - 1;
     if(gTvTextCog > 0) {
        Asm("cogstop %id");           /* maybe this is OK but NOT SURE ABOUT SYNTAX  */             
     }
   }

/*
TV_Text setcolors function sets the palette to that defined by pointer.
See header file for more details. */
 
void tvText_setColorPalette(char* ptr)
{   int  ii = 0;
    int  mm = 0;
    int  fg = 0;
    int  bg = 0;
    for(ii = 0; ii < TV_TEXT_COLORTABLE_SIZE; ii += 2)
      { mm = ii + 1; 
        fg = ptr[ii] << 0;
        bg = ptr[mm] << 0;
        gcolors[ii]  = fg << 24 | bg << 16 | fg << 8 | bg;
        gcolors[mm]  = fg << 24 | fg << 16 | bg << 8 | bg;
      }        
}


void tvText_dec(int value)
 {  char b[128];
    itoa(b, value, 10);
    tvText_str(b);
 }

void tvText_str(char* sptr)
{   
    int l,k;
    l=(TV_TEXT_SCREENSIZE-39);
    while(*sptr) {
        k =(*(sptr++));
		gscreen[l++]=((2<< 1 | k & 1) << 10) + (0x200 + (k & 0xfe));
    }
}


/* the CMD> method is experimental at this stage, but it is envisaged that is will do an auto save 
of the text buffer to SDcard and provide users with access to other user functions. 
*/


void cmd()                         
 {
	 int m = 0 ;
	 int i = 0;
	 int l = TV_TEXT_SCREENSIZE-30;
	 short int ix; 
     for(ix=(TV_TEXT_SCREENSIZE-39) ; ix<=(TV_TEXT_SCREENSIZE-2) ;  ix++)
     {  gscreen[ix]=((2 << 1 | SPACE & 1) << 10) + (0x200 + (SPACE & 0xfe)); }
	 tvText_str("CMD>");
	 while(cx != RETN)
       { waitcnt(CLKFREQ/120+CNT)            
	     getcx();
	     if (i<=20)
	     {	if (cx!=0x0)
	    	{ gscreen[l++]=((2<< 1 | cx & 1) << 10) + (0x200 + (cx & 0xfe));
	          cmdbuf[i++] = cx; }
	     }
	    }
    /* execute cmd string here or return to editor	*/ 
   }
	
	
	
	
void getcx()                     /* unload keyboard buffer and decode arrow key for my tiny Prop WP */
{
if(j!=z)                                       /* is buffer empty ??   'z' is input pointer in Keyin */
	 {
	 j++;
 	 if (j>=60){j=0;}                          /* rewind buffer 'j' output pointer  */
			cx =kb[j];                         /* get next char in buffer           */
			  if (cx==0x1b)                    /* look for arrow key sequence       */
			      {
				  j++;
				  if (j>=60){j=0;}   
				  waitcnt(CLKFREQ/200 + CNT);  /* don't check too early  */ 
		       	  if (kb[j]== 0x5b )           /* check next key in sequence */
	              		{
						j++;
						if (j>=60){j=0;}   
				        cx= 0x80 + kb[j];      /* found it, now modify for my tvText_out  */
						return;                /* return with arrow code                  */ 
				        }
					cx=0x0;	                   /* not decoded hook for other sequences    */
					return;
				  } 		
			return;                           /* normal return                            */	    
     }
	cx=0x0;	                                  /* buffer empty                             */
	return; 	 
}


void keyin()            /* buffer RxByte required to trap ESC keyboard Sequences (repeated arrow keys)   */ 
  {                     /* this uses a COG, so maybe I can service something else here as well.  
  while (1)
     {  cx = RxByte(RXPIN,BAUD) ;
        if (cx!=0x00)
        { z++;	
 	      if (z>=60){z=0;}              /* rewind pointer  */
	      kb[z]=cx;  
        }   	
      }
   }

void    tvText_out(int c)             
   {switch(c)
       {   case cls:
                WordFill(&gscreen[0], color << 11 |0x220, TV_TEXT_SCREENSIZE);   
                po= 0;
                pb = 0;
                break;
            case home:
                po = 0;
                pb = 0;
                break;
            case esc:  
			    cmd();
			    break;  
            case tab:         /* fall though ATM  */
            case 0x0A:        /* fall though ATM  */
            case BS:          /* fall though ATM  */ 
	            if (pb >= 0)
			  { buf[pb] = 0x20;
			    pb--;
			    cc = buf[pb];
			    buf[pb] = '_'; }
			    break;	
            case 0x0c:        /* fall though ATM   */ 
            case RETN:  
	            retx();	
				break;	
			case up:
			if (pb >= TV_TEXT_COLS)
	        {  if ((pb - po) <= TV_TEXT_COLS) { po -= TV_TEXT_COLS;}
 			   else
			{  buf[pb]=cc;
			   pb -= TV_TEXT_COLS;
			   cc = buf[pb];
			   buf[pb]='_';  }
			}	
			  break; 	 
			  case down:
			  if (pb <= buflen)
			{ if (pb - po > TV_TEXT_SCREENSIZE) { po += TV_TEXT_COLS; }
			  else
		    { buf[pb] = cc;
			  pb += TV_TEXT_COLS;
			  cc = buf[pb];
			  buf[pb] = '_';	}
			}
			break;
			case right:
			if (pb <= buflen)
			{
			buf[pb] = cc;
			  pb++;
			  cc = buf[pb];
			  buf[pb] = '_';
			} 
			break;  
			case left:
			if (pb >= 0)
			  {
			  buf[pb] = cc;
			  pb--;
			  cc = buf[pb];
			  buf[pb] = '_';
			  }
			break;  
			default:	
			buf[pb] = c;   	   				 /* save new character in buffer  */
			pb++;           		         /* inc pointer    */
			cc = buf[pb];  			  		 /* save current cursor position  */
			buf[pb] ='_';      		   		 /* write new cursor              */
		 }     
         screen_update();                    /* update screen ..keep in sync  *? 
}        

/* keep text buffer in snyc with gscreen ....
...re visit this. Bug when row=col= 0 meets arrow up, therefore there may be others */

void screen_update()
   { int i;
	 if ((pb-po)>=lastrow){	 po += 40;}       
	 for (i=0; i<=lastrow  ; i++ ) {gscreen[i]=((color << 1 | buf[po + i] & 1) << 10) + (0x200 + (buf[po + i] & 0xfe)); }	 
   }
	 

void retx()                             
{	 									 
    int v,k,j,i,temp;					 
	v =1+(pb/TV_TEXT_COLS);             /* calculate number of lines in buffer include part line */ 
	v = v*40;                           /* therefore there are v bytes in Text buffer */
    k = (pb % TV_TEXT_COLS);            /* calculate chars on current line   */
	buf[pb]=cc;                         /* always got to save char that cursor is sitting on */
	CharMove( buflen,buflen-TV_TEXT_COLS, v/40 ); /* move all char below this line dowm 1 line  */
	CharFill( buf[v], TV_TEXT_COLS,SPACE );       /* clear the line for new text */
	CharMove( buf[v],buf[pb],TV_TEXT_COLS-(k+1))  /* move chars from Cursor to EOL, to line below */
	CharFill( buf[pb],TV_TEXT_COLS-(k+1),SPACE)   /* now clear from cursor to EOL */
	pb=v;                                         /* restore cursor  */
	buf[pb]="_";                                  /* write it        */
	}


